/*******************************************************************************
 * Copyright 2019, 2020 grondag
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not
 * use this file except in compliance with the License.  You may obtain a copy
 * of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
 * WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.  See the
 * License for the specific language governing permissions and limitations under
 * the License.
 ******************************************************************************/
package grondag.fluidity.base.synch;

import io.netty.buffer.Unpooled;
import org.apiguardian.api.API;
import org.apiguardian.api.API.Status;
import net.fabricmc.fabric.api.network.ServerSidePacketRegistry;
import net.minecraft.class_2540;
import net.minecraft.class_2596;
import net.minecraft.class_2960;
import net.minecraft.class_3222;
import grondag.fluidity.Fluidity;
import grondag.fluidity.api.article.Article;

@API(status = Status.EXPERIMENTAL)
public final class DiscreteStorageUpdateS2C {
	private DiscreteStorageUpdateS2C() {}

	public static class_2540 begin(int count) {
		final class_2540 buf = new class_2540(Unpooled.buffer());
		buf.writeInt(count);
		return buf;
	}

	public static class_2540 append(class_2540 buf, Article article, long count, int handle) {
		article.toPacket(buf);
		buf.method_10791(count);
		buf.method_10804(handle);
		return buf;
	}

	public static void sendFullRefresh(class_3222 player, class_2540 buf, long capacity) {
		buf.method_10791(capacity);
		send(ID_FULL_REFRESH, player, buf);
	}

	public static void sendUpdateWithCapacity(class_3222 player, class_2540 buf, long capacity) {
		buf.method_10791(capacity);
		send(ID_UPDATE_WITH_CAPACITY, player, buf);
	}

	public static void sendUpdate(class_3222 player, class_2540 buf) {
		send(ID_UPDATE, player, buf);
	}

	private static void send(class_2960 id, class_3222 player, class_2540 buf) {
		final class_2596<?> packet = ServerSidePacketRegistry.INSTANCE.toPacket(id, buf);
		ServerSidePacketRegistry.INSTANCE.sendToPlayer(player, packet);
	}

	public static class_2960 ID_FULL_REFRESH = new class_2960(Fluidity.MOD_ID, "dfrs2c");
	public static class_2960 ID_UPDATE = new class_2960(Fluidity.MOD_ID, "duds2c");
	public static class_2960 ID_UPDATE_WITH_CAPACITY = new class_2960(Fluidity.MOD_ID, "ducs2c");
}
