/*******************************************************************************
 * Copyright 2019, 2020 grondag
 * 
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not
 * use this file except in compliance with the License.  You may obtain a copy
 * of the License at
 * 
 *   http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
 * WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.  See the
 * License for the specific language governing permissions and limitations under
 * the License.
 ******************************************************************************/
package grondag.fluidity.base.transact;


import org.apiguardian.api.API;
import org.apiguardian.api.API.Status;
import grondag.fluidity.api.storage.InventoryStore;
import grondag.fluidity.api.transact.TransactionContext;
import grondag.fluidity.impl.article.StackHelper;
import net.minecraft.class_1263;
import net.minecraft.class_1799;

@API(status = Status.EXPERIMENTAL)
public class TransactionHelper {

	public static Object prepareInventoryRollbackState(InventoryStore storage) {
		final int size = storage.method_5439();
		final class_1799[] state = new class_1799[size];

		for (int i = 0; i < size; i++) {
			state[i] = storage.method_5438(i).method_7972();
		}

		return state;

	}

	public static void prepareInventoryRollbackHandler(TransactionContext context, InventoryStore storage) {
		context.setState(prepareInventoryRollbackState(storage));
	}

	public static void applyInventoryRollbackState(Object state, class_1263 storage) {
		final int size = storage.method_5439();
		final class_1799[] stacks = (class_1799[]) state;

		for (int i = 0; i < size; i++) {
			final class_1799 myStack = storage.method_5438(i);
			final class_1799 stateStack = stacks[i];

			if (StackHelper.areStacksEqual(myStack, stateStack)) {
				continue;
			}

			storage.method_5447(i, stateStack);
		}
	}

	public static void applyInventoryRollbackHandler(TransactionContext context, class_1263 storage) {
		if (!context.isCommited()) {
			applyInventoryRollbackState(context.getState(), storage);
		}
	}
}
