/*******************************************************************************
 * Copyright 2019, 2020 grondag
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not
 * use this file except in compliance with the License.  You may obtain a copy
 * of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
 * WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.  See the
 * License for the specific language governing permissions and limitations under
 * the License.
 ******************************************************************************/
package grondag.fluidity.impl.device;

import java.util.function.Function;
import net.minecraft.class_1937;
import net.minecraft.class_2350;
import net.minecraft.class_2960;
import org.apache.commons.lang3.ObjectUtils;
import grondag.fluidity.api.device.Authorization;
import grondag.fluidity.api.device.ComponentContext;
import grondag.fluidity.api.device.DeviceComponentAccess;
import grondag.fluidity.api.device.DeviceComponentType;

@SuppressWarnings("rawtypes")
abstract class AbstractComponentContextImpl implements ComponentContext, DeviceComponentAccess {
	protected DeviceComponentTypeImpl componentType;
	protected Function<ComponentContext, ?> mapping;
	protected class_1937 world;
	protected class_2960 id;
	protected class_2350  side;
	protected Authorization auth;

	@Override
	public final Object get(Authorization auth, class_2350 side, class_2960 id) {
		this.auth = auth;
		this.side = side;
		this.id = id;
		return ObjectUtils.defaultIfNull(mapping.apply(this), componentType.absent());
	}

	@Override
	public final DeviceComponentType componentType() {
		return componentType;
	}

	@Override
	public final class_2960 id() {
		return id;
	}

	@Override
	public final class_2350 side() {
		return side;
	}

	@Override
	public final Authorization auth() {
		return auth;
	}

	protected abstract class_1937 getWorldLazily();

	@Override
	public final class_1937 world() {
		class_1937 result = world;

		if(result == null) {
			result = getWorldLazily();
			world = result;
		}

		return result;
	}
}
