/*******************************************************************************
 * Copyright 2019, 2020 grondag
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not
 * use this file except in compliance with the License.  You may obtain a copy
 * of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
 * WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.  See the
 * License for the specific language governing permissions and limitations under
 * the License.
 ******************************************************************************/
package grondag.fluidity.impl.device;

import grondag.fluidity.api.device.BlockComponentContext;
import net.minecraft.class_1937;
import net.minecraft.class_2248;
import net.minecraft.class_2338;
import net.minecraft.class_2586;
import net.minecraft.class_2680;

@SuppressWarnings("rawtypes")
public final class BlockComponentContextImpl extends AbstractComponentContextImpl implements BlockComponentContext {
	private class_2248 block;
	private class_2338 pos;
	private class_2680 blockState;
	private class_2586 blockEntity;

	@Override
	public class_2248 block() {
		return block;
	}

	@Override
	public class_2338 pos() {
		class_2338 result = pos;

		if(result == null && blockEntity != null) {
			result = blockEntity.method_11016();
			pos = result;
		}

		return result;
	}

	@Override
	public class_2586 blockEntity() {
		class_2586 result = blockEntity;

		if(result == null && world != null) {
			result = world.method_8321(pos);
			blockEntity = result;
		}

		return result;
	}

	@Override
	public class_2680 blockState() {
		return blockState;
	}

	@Override
	protected class_1937 getWorldLazily() {
		return blockEntity == null ? null : blockEntity.method_10997();
	}

	@SuppressWarnings("unchecked")
	private BlockComponentContextImpl prepare(DeviceComponentTypeImpl componentType, class_1937 world, class_2338 pos) {
		this.componentType = componentType;
		this.world = world;
		this.pos = pos;
		blockEntity = null;
		blockState = world.method_8320(pos);
		block = blockState.method_26204();
		mapping = componentType.getMapping(block);
		return this;
	}

	@SuppressWarnings("unchecked")
	private BlockComponentContextImpl  prepare(DeviceComponentTypeImpl componentType, class_1937 world, class_2338 pos, class_2680 blockState) {
		this.componentType = componentType;
		this.world = world;
		this.pos = pos;
		blockEntity = null;
		this.blockState = blockState;
		block = blockState.method_26204();
		mapping = componentType.getMapping(block);
		return this;
	}

	@SuppressWarnings("unchecked")
	private BlockComponentContextImpl prepare(DeviceComponentTypeImpl componentType, class_2586 blockEntity) {
		this.componentType = componentType;
		world = null;
		pos = null;
		this.blockEntity = blockEntity;
		blockState = blockEntity.method_11010();
		block = blockState.method_26204();
		mapping = componentType.getMapping(block);
		return this;
	}

	private static final ThreadLocal<BlockComponentContextImpl> POOL = ThreadLocal.withInitial(BlockComponentContextImpl::new);

	static BlockComponentContextImpl get(DeviceComponentTypeImpl componentType, class_1937 world, class_2338 pos) {
		return POOL.get().prepare(componentType, world, pos);
	}

	static BlockComponentContextImpl  get(DeviceComponentTypeImpl componentType, class_1937 world, class_2338 pos, class_2680 blockState) {
		return POOL.get().prepare(componentType, world, pos, blockState);
	}

	static BlockComponentContextImpl get(DeviceComponentTypeImpl componentType, class_2586 blockEntity) {
		return POOL.get().prepare(componentType, blockEntity);
	}
}
